import React from 'react';
import { addons, types } from '@storybook/addons';
import { ADDON_ID, PANEL_ID, PARAM_KEY } from './constants';
import Panel from './Panel';
addons.register(ADDON_ID, function () {
  var channel = addons.getChannel();
  addons.add(PANEL_ID, {
    title: 'Playroom',
    type: types.TAB,
    route: function route(_ref) {
      var storyId = _ref.storyId;
      return "/playroom/".concat(storyId);
    },
    match: function match(_ref2) {
      var viewMode = _ref2.viewMode;
      return viewMode === 'playroom';
    },
    render: function render(_ref3) {
      var active = _ref3.active;
      return /*#__PURE__*/React.createElement(Panel, {
        active: active,
        channel: channel
      });
    },
    paramKey: PARAM_KEY
  });
});